import es
import popuplib
import playerlib
from xa import xa

mymodule   = xa.register('gungameadmin')
xalanguage = mymodule.language.getLanguage()

admins = {}
scripts = {
            'gg_turbo_mode':'Turbo',
            'gg_earn_nade':'Earn Grenades',
            'gg_unl_grenade':'Unlimited Grenades',
            'gg_knife_pro':'Knife Pro',
            'gg_knife_elite':'Knife Elite',
            'gg_nade_bonus':'Grenade Bonus',
            'gg_noblock':'No-Block'
            }

info                = es.AddonInfo() 
info.name           = "GunGame Admin" 
info.version        = "0.1" 
info.author         = "freddukes" 
info.url            = "http://forums.mattie.info/" 
info.description    = "Vote Module for eXtensible Admin"

es.ServerVar('gungameadmin',info.version,'GunGame Admin menu for eXtensible Admin.').makepublic()

customaddonslist = mymodule.configparser.getList('customaddons.txt')

def load():
    ggmenu = popuplib.easymenu("ggadminmenu", "_popup_choice", gunGameMenuSelect)
    ggmenu.settitle(xalanguage["manage gungame"])
    ggmenu.addoption('players',       xalanguage["manage players"])
    ggmenu.addoption('addons',        xalanguage["manage addons"])
    if customaddonslist:
        ggmenu.addoption('custom_addons', xalanguage["custom addons"])
        buildCustomAddonsMenu()
    mymodule.addMenu("ggadminmenu",   xalanguage["manage gungame"], "ggadminmenu", "gungame_manage", "#admin")
    
    playersmenu = popuplib.easymenu("gungameplayermenu", "_popup_choice", sendPlayerMenu)
    playersmenu.settitle(xalanguage["manage players"])
    playersmenu.addoption('increase', xalanguage["increase level"])
    playersmenu.addoption('decrease', xalanguage["decrease level"])
    playersmenu.addoption('set',      xalanguage["set level"])
    playersmenu.submenu(10, 'ggadminmenu')
    
    targetmenu = popuplib.easymenu("gungametarget", "_tempcore", selectTarget)
    targetmenu.settitle(xalanguage["choose target"])
    targetmenu.addoption("player", xalanguage["select a player"])
    targetmenu.addoption("team3",  xalanguage["counter terrorists"])
    targetmenu.addoption("team2",  xalanguage["terrorists"])
    targetmenu.addoption("all",    xalanguage["all players"])
    targetmenu.submenu(10, 'gungameplayermenu')
    
    buildAddonsMenu()
    
    mymodule.addCommand('xa_setgglevel', setGunGameLevel, 'gungame_manage', '#admin').register(('console'))
    
def unload():
    xa.unregister('gungameadmin')

def player_disconnect(ev):
    if admins.has_key(int(ev['userid'])):
        del admins[int(ev['userid'])]
    
def gunGameMenuSelect(userid, choice, popupid):
    if choice == "players":
        popuplib.send("gungameplayermenu", userid)
    elif choice == "addons":
        buildAddonsMenu()
        popuplib.send("ggaddons", userid)
    elif choice == "custom_addons":
        buildCustomAddonsMenu()
        popuplib.send("ggcustomaddons", userid)
        
def sendPlayerMenu(userid, choice, popupid):
    if not admins.has_key(userid):
        admins[userid] = {}
    admins[userid]['gungamecommand'] = choice
    popuplib.send("gungametarget", userid)
    
def selectTarget(userid, choice, popupid):
    if choice == "player":
        singleplayermenu = popuplib.construct("ggsingleplayermenu", "players", "#all")
        singleplayermenu.settitle(xalanguage["select a player"])
        singleplayermenu.menuselectfb = selectPlayer
        singleplayermenu.send(userid)
    else:
        if choice == "team3":
            playerlist = filter(lambda x: es.getplayerteam(x) == 3, es.getUseridList())
        elif choice == "team2":
            playerlist = filter(lambda x: es.getplayerteam(x) == 2, es.getUseridList())
        elif choice == "all":
            playerlist = es.getUseridList()
        if admins[userid]['gungamecommand'] == 'set':
            admins[userid]['playerlist'] = playerlist
            es.escinputbox(30, userid, '=== XA GunGame Admin - Set Level ===', 'Enter the level Value', 'xa_setgglevel')
            es.tell(userid, '#multi', xalanguage('escape box', lang=playerlib.getPlayer(userid).get("lang")))
        else:
            for player in playerlist:
                if admins[userid]['gungamecommand'] == 'increase':
                    es.server.queuecmd('gg_levelup %s'%player)
                    tokens = {}
                    tokens['admin'] = es.getplayername(userid)
                    tokens['player'] = es.getplayername(player)
                    for player in playerlib.getPlayerList('#human'):
                        es.tell(int(player), '#multi', xalanguage('admin increment', tokens, player.get("lang")))
                elif admins[userid]['gungamecommand'] == 'decrease':
                    es.server.queuecmd('gg_leveldown %s'%player)
                    tokens = {}
                    tokens['admin'] = es.getplayername(userid)
                    tokens['player'] = es.getplayername(player)
                    for player in playerlib.getPlayerList('#human'):
                        es.tell(int(player), '#multi', xalanguage('admin decrement', tokens, player.get("lang")))
        
def selectPlayer(userid, choice, popupid):
    if admins[userid]['gungamecommand'] == 'increase':
        es.server.queuecmd('gg_levelup %s'%choice)
        tokens = {}
        tokens['admin'] = es.getplayername(userid)
        tokens['player'] = es.getplayername(choice)
        for player in playerlib.getPlayerList('#human'):
            es.tell(int(player), '#multi', xalanguage('admin increment', tokens, player.get("lang")))
    elif admins[userid]['gungamecommand'] == 'decrease':
        es.server.queuecmd('gg_leveldown %s'%choice)
        tokens = {}
        tokens['admin'] = es.getplayername(userid)
        tokens['player'] = es.getplayername(choice)
        for player in playerlib.getPlayerList('#human'):
            es.tell(int(player), '#multi', xalanguage('admin decrement', tokens, player.get("lang")))
    else:
        admins[userid]['playerlist'] = [choice]
        es.escinputbox(30, userid, '=== XA GunGame Admin - Set Level ===', 'Enter the level Value', 'xa_setgglevel')
        es.tell(userid, '#multi', xalanguage('escape box', lang=playerlib.getPlayer(userid).get("lang")))
                    
def setGunGameLevel():
    admin  = es.getplayername(es.getcmduserid())
    amount = es.getargv(1)
    for player in admins[es.getcmduserid()]['playerlist']:
        es.server.queuecmd('gg_setlevel %s %s'%(player, amount))
        tokens = {}
        tokens['amount'] = amount
        tokens['admin']  = admin
        tokens['player'] = es.getplayername(player)
        for player in playerlib.getPlayerList('#human'):
            es.tell(int(player), '#multi', xalanguage('admin set level', tokens, player.get("lang")))

def addonSelection(userid, choice, popupid):
    mod = 'gungame4/addons/%s'%choice
    tokens = {}
    tokens['script'] = scripts[choice]
    if not scriptExists(mod):
        es.load(mod)
        for player in playerlib.getPlayerList('#human'):
            tokens['status'] = xalanguage('loaded', lang=player.get("lang"))            
            es.tell(int(player), '#multi', xalanguage('load or unload', tokens, player.get("lang")))
    else:
        es.unload(mod)
        for player in playerlib.getPlayerList('#human'):
            tokens['status'] = xalanguage('unloaded', lang=player.get("lang"))            
            es.tell(int(player), '#multi', xalanguage('load or unload', tokens, player.get("lang")))
    
def customAddonSelection(userid, choice, popupid):
    mod = 'gungame4/addons/custom/%s'%choice
    tokens = {}
    tokens['script'] = scripts[choice]
    if not scriptExists(mod):
        es.load(mod)
        for player in playerlib.getPlayerList('#human'):
            tokens['status'] = xalanguage('loaded', lang=player.get("lang"))            
            es.tell(int(player), '#multi', xalanguage('load or unload', tokens, player.get("lang")))
    else:
        es.unload(mod)
        for player in playerlib.getPlayerList('#human'):
            tokens['status'] = xalanguage('unloaded', lang=player.get("lang"))            
            es.tell(int(player), '#multi', xalanguage('load or unload', tokens, player.get("lang")))
    
''' The following check was made by SD!!! <3 '''
def scriptExists(str_script_name):
    return bool(filter(lambda module_x: module_x.__name__[0:module_x.__name__.rfind('.')].replace('.', '/') == str_script_name, es.addons.getAddonList()) or es.exists('script', str_script_name)) 

def buildAddonsMenu():
    addons = popuplib.easymenu("ggaddons","_popup_choice", addonSelection)
    addons.addoption("gg_turbo_mode","Turbo" if not scriptExists("gungame4/addons/gg_turbo_mode") else "* Turbo")
    addons.addoption("gg_earn_nade", "Earn Grenades" if not scriptExists("gungame4/addons/gg_earn_nade") else "* Earn Grenades")
    addons.addoption("gg_unl_grenade", "Unlimited Grenades" if not scriptExists("gungame4/addons/gg_unl_grenade") else "* Unlimited Grenades")
    addons.addoption("gg_knife_pro", "Knife Pro" if not scriptExists("gungame4/addons/gg_knife_pro") else "* Knife Pro")
    addons.addoption("gg_knife_elite", "Knife Elite" if not scriptExists("gungame4/addons/gg_knife_elite") else "* Knife Elite")
    addons.addoption("gg_nade_bonus", "Grenade Bonus" if not scriptExists("gungame4/addons/gg_nade_bonus") else "* Grenade Bonus")
    addons.addoption("gg_noblock", "No-Block" if not scriptExists("gungame4/addons/gg_noblock") else "* No-Block")
    addons.settitle(xalanguage["manage addons"])
    addons.submenu(10, 'ggadminmenu')
    
def buildCustomAddonsMenu():
    customaddons = popuplib.easymenu("ggcustomaddons","_popup_choice", customAddonSelection)
    for addon in customaddonslist:
        loadname    = addon.split('"')[1]
        displaymenu = addon.split('"')[3]
        scripts[loadname] = displaymenu
        customaddons.addoption(loadname, displaymenu if not scriptExists("gungame4/addons/custom/%s"%loadname) else "* " + displaymenu)
    customaddons.settitle(xalanguage["custom addons"])
    customaddons.submenu(10, 'ggadminmenu')
